#!C:\Programme\Python25\python.exe
# -*- coding: UTF-8 -*-

import os, sys, Cookie, hashlib, cgitb, cgi, time, random
cgitb.enable()
 
# ***** include the biocase.lib directory in the python sys path for importing *****
execfile( os.path.abspath( os.path.join( os.path.dirname( __file__ ), os.pardir, os.pardir, 'lib', 'biocase', 'adjustpath.py' ) ))
execfile( os.path.abspath( os.path.join( os.path.dirname( __file__ ), os.pardir, os.pardir, 'lib', 'biocase', 'appinit.py' ) ))

from biocase.configtool.general import *
from biocase import __version__

# check authentication!
if dsa is None:
    execfile( os.path.abspath( os.path.join( os.path.dirname( __file__ ), 'main.cgi' ) ))
    sys.exit()

# check authentication!
authorize(form, dsa=dsa)

# check archive folders
dldPath = os.path.join(cfg.archiveDownloadLocator, dsa)
archivePath = os.path.join(cfg.archiveWorkLocator, dsa)
if not os.path.exists(archivePath):
    os.makedirs(archivePath)
if not os.path.exists(dldPath):
    os.makedirs(dldPath)

# load html template
tmpl = PageMacro('Content', PageMacro.DELMODE)
tmpl.load('Content', os.path.join(templateDir, '_archive.html'))

psfObj = dsaObj.getPSFObj(tmp=False)
p = psfObj.adminpassword
if p == None:
	random.seed(time.time())
	p = str(random.random())

m = hashlib.md5()
m.update(dsa + p)
tmpl['ticket'] = m.hexdigest()

# fill template
# general stuff
tmpl['dsa'] = dsa
tmpl['wrapper_url'] = dsaObj.getBioCASeAccessPoint()
tmpl['ServiceTitle'] = 'BioCASe Provider Software %s' % __version__

slObj = dsaObj.getSchemaListObj()
DsaSchemaList = []
tmpl['disable'] = 'disabled="disabled"'
for sObj in slObj:
	tmpl['disable'] = ''
	entry = {}
	entry['schema'] = sObj.name[:-4]
	entry['schema_file'] = os.path.split(sObj.file)[1]
	entry['namespace'] = sObj.NS
	entry['num_mappings'] = str(sObj.mappings)
	DsaSchemaList.append( entry )
tmpl.expand('Content', 'schemalist', DsaSchemaList)

printOverHTTP (tmpl)
